aboutsummaryrefslogtreecommitdiffstats
diff options
context:
space:
mode:
authorAnand Jain <anand.jain@oracle.com>2018-06-01 23:57:26 +0800
committerEryu Guan <guaneryu@gmail.com>2018-06-03 22:16:15 +0800
commitf3a33a9dda1ee6f029f47c2b6cd82aba67f05bd8 (patch)
tree07cee5cd6afba8671e6115ebd278e110e1532332
parenta281d39579a45724c2761a31f9d8b989b8443d21 (diff)
downloadxfstests-dev-f3a33a9dda1ee6f029f47c2b6cd82aba67f05bd8.tar.gz
btrfs: seed device delete test
Test case to verify that a seed device can be deleted Signed-off-by: Anand Jain <anand.jain@oracle.com> Reviewed-by: Eryu Guan <guaneryu@gmail.com> Signed-off-by: Eryu Guan <guaneryu@gmail.com>
-rwxr-xr-xtests/btrfs/164111
-rw-r--r--tests/btrfs/164.out9
-rw-r--r--tests/btrfs/group1
3 files changed, 121 insertions, 0 deletions
diff --git a/tests/btrfs/164 b/tests/btrfs/164
new file mode 100755
index 0000000000..ec70c371cd
--- /dev/null
+++ b/tests/btrfs/164
@@ -0,0 +1,111 @@
+#! /bin/bash
+# FS QA Test 164 seed device delete test
+#
+# Test case to verify that a seed device can be deleted
+# Create a seed device
+# Create a sprout device
+# Remount RW
+# Run device delete on the seed device
+#-----------------------------------------------------------------------
+# Copyright (c) 2018 Oracle. All Rights Reserved.
+#
+# This program is free software; you can redistribute it and/or
+# modify it under the terms of the GNU General Public License as
+# published by the Free Software Foundation.
+#
+# This program is distributed in the hope that it would be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write the Free Software Foundation,
+# Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+#-----------------------------------------------------------------------
+#
+
+seq=`basename $0`
+seqres=$RESULT_DIR/$seq
+echo "QA output created by $seq"
+
+here=`pwd`
+tmp=/tmp/$$
+status=1 # failure is the default!
+trap "_cleanup; exit \$status" 0 1 2 3 15
+
+_cleanup()
+{
+ cd /
+ rm -f $tmp.*
+}
+
+# get standard environment, filters and checks
+. ./common/rc
+. ./common/module
+
+# remove previous $seqres.full before test
+rm -f $seqres.full
+
+# real QA test starts here
+
+# Modify as appropriate.
+_supported_fs btrfs
+_supported_os Linux
+_require_loadable_fs_module "btrfs"
+_require_scratch_dev_pool 2
+
+_scratch_dev_pool_get 2
+
+dev_seed=$(echo $SCRATCH_DEV_POOL | awk '{print $1}')
+dev_sprout=$(echo $SCRATCH_DEV_POOL | awk '{print $2}')
+
+create_seed()
+{
+ _mkfs_dev $dev_seed
+ run_check _mount $dev_seed $SCRATCH_MNT
+ $XFS_IO_PROG -f -d -c "pwrite -S 0xab 0 256K" $SCRATCH_MNT/foobar >\
+ /dev/null
+ echo -- gloden --
+ od -x $SCRATCH_MNT/foobar
+ _run_btrfs_util_prog filesystem show -m $SCRATCH_MNT
+ _scratch_unmount
+ $BTRFS_TUNE_PROG -S 1 $dev_seed
+ run_check _mount $dev_seed $SCRATCH_MNT
+}
+
+add_sprout()
+{
+ _run_btrfs_util_prog device add -f $dev_sprout $SCRATCH_MNT
+ run_check mount -o rw,remount $dev_seed $SCRATCH_MNT
+ _run_btrfs_util_prog filesystem show -m $SCRATCH_MNT
+}
+
+delete_seed()
+{
+ _run_btrfs_util_prog device delete $dev_seed $SCRATCH_MNT
+ _scratch_unmount
+ _reload_fs_module "btrfs"
+ run_check _mount $dev_sprout $SCRATCH_MNT
+ _run_btrfs_util_prog filesystem show -m $SCRATCH_MNT
+ echo -- sprout --
+ od -x $SCRATCH_MNT/foobar
+ _scratch_unmount
+}
+
+seed_is_mountable()
+{
+ run_check _mount $dev_seed $SCRATCH_MNT
+ _run_btrfs_util_prog filesystem show -m $SCRATCH_MNT
+ _scratch_unmount
+}
+
+create_seed
+add_sprout
+delete_seed
+
+seed_is_mountable
+
+_scratch_dev_pool_put
+
+status=0
+exit
diff --git a/tests/btrfs/164.out b/tests/btrfs/164.out
new file mode 100644
index 0000000000..c073b7a88a
--- /dev/null
+++ b/tests/btrfs/164.out
@@ -0,0 +1,9 @@
+QA output created by 164
+-- gloden --
+0000000 abab abab abab abab abab abab abab abab
+*
+1000000
+-- sprout --
+0000000 abab abab abab abab abab abab abab abab
+*
+1000000
diff --git a/tests/btrfs/group b/tests/btrfs/group
index 50e69de95d..e908fff551 100644
--- a/tests/btrfs/group
+++ b/tests/btrfs/group
@@ -166,3 +166,4 @@
161 auto quick
162 auto quick
163 auto quick
+164 auto quick